Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3968)
@@ -25,4 +25,18 @@
 ! -----------------
 ! $Id$
+! - clean-up index notations for emission_values to eliminate magic numbers
+! - introduce temporary variable dum_var_5d as well as subroutines
+!   get_var_5d_real and get_var_5d_real_dynamic
+! - remove emission-specific code in generic get_variable routines
+! - in subroutine netcdf_data_input_chemistry_data change netCDF LOD 1 
+!   (default) emission_values to the following index order:
+!   z, y, x, species, category
+! - in subroutine netcdf_data_input_chemistry_data
+!   changed netCDF LOD 2 pre-processed emission_values to the following index 
+!   order: time, z, y, x, species
+! - in type chem_emis_att_type replace nspec with n_emiss_species
+!   but retained nspec for backward compatibility with salsa_mod. (E.C. Chan)
+! 
+! 3961 2019-05-08 16:12:31Z suehring
 ! Revise checks for building IDs and types
 ! 
@@ -289,10 +303,9 @@
 ! Initial revision (suehring)
 !
-!
-!
-!
 ! Authors:
 ! --------
 ! @author Matthias Suehring
+! @author Edward C. Chan
+! @author Emanuele Russo
 !
 ! Description:
@@ -300,10 +313,17 @@
 !> Modulue contains routines to input data according to Palm input data
 !> standart using dynamic and static input files.
-!> @todo - Chemistry: revise reading of netcdf file and ajdust formatting according to standard!!!
+!> @todo - Chemistry: revise reading of netcdf file and ajdust formatting
+!>         according to standard!!! (ecc/done)
 !> @todo - Order input alphabetically
 !> @todo - Revise error messages and error numbers
 !> @todo - Input of missing quantities (chemical species, emission rates)
 !> @todo - Defninition and input of still missing variable attributes
+!>         (ecc/what are they?)
 !> @todo - Input of initial geostrophic wind profiles with cyclic conditions.
+!> @todo - remove z dimension from default_emission_data nad preproc_emission_data
+!          and correpsonding subroutines get_var_5d_real and get_var_5d_dynamic (ecc)
+!> @todo - decpreciate chem_emis_att_type@nspec (ecc)
+!> @todo - depreciate subroutines get_variable_4d_to_3d_real and
+!>         get_variable_5d_to_4d_real (ecc)
 !------------------------------------------------------------------------------!
  MODULE netcdf_data_input_mod
@@ -348,5 +368,5 @@
        CHARACTER(LEN=17) ::  char_s = 'ls_forcing_south_' !< leading substring for variables at south boundary 
        CHARACTER(LEN=15) ::  char_t = 'ls_forcing_top_'   !< leading substring for variables at top boundary 
-    
+
        CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names         !< list of variable in dynamic input file
        CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_l  !< names of mesoscale nested chemistry variables at left boundary
@@ -363,5 +383,5 @@
 
        LOGICAL      ::  init         = .FALSE. !< flag indicating that offline nesting is already initialized
-       
+
        LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_l !< flags inidicating whether left boundary data for chemistry is in dynamic input file  
        LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_n !< flags inidicating whether north boundary data for chemistry is in dynamic input file 
@@ -491,52 +511,52 @@
 
        !-DIMENSIONS
-       INTEGER(iwp)                                 :: nspec=0                   !< number of chem species for which emission values are provided
-       INTEGER(iwp)                                 :: ncat=0                    !< number of emission categories
-       INTEGER(iwp)                                 :: nvoc=0                    !< number of VOCs components
-       INTEGER(iwp)                                 :: npm=0                     !< number of PMs components
-       INTEGER(iwp)                                 :: nnox=2                    !< number of NOx components: NO and NO2
-       INTEGER(iwp)                                 :: nsox=2                    !< number of SOx components: SO and SO4
-       INTEGER(iwp)                                 :: nhoursyear                !< number of hours of a specific year in the HOURLY mode
-                                                                                 !  of the default mode
-       INTEGER(iwp)                                 :: nmonthdayhour             !< number of month days and hours in the MDH mode 
-                                                                                 !  of the default mode
-       INTEGER(iwp)                                 :: dt_emission               !< Number of emissions timesteps for one year 
-                                                                                 !  in the pre-processed emissions case
+       
+       INTEGER(iwp)                                 :: nspec=0            !< no of chem species provided in emission_values
+       INTEGER(iwp)                                 :: n_emiss_species=0  !< no of chem species provided in emission_values
+                                                                          !< same function as nspec, which will be depreciated (ecc)
+                                                                                 
+       INTEGER(iwp)                                 :: ncat=0             !< number of emission categories
+       INTEGER(iwp)                                 :: nvoc=0             !< number of VOC components
+       INTEGER(iwp)                                 :: npm=0              !< number of PM components
+       INTEGER(iwp)                                 :: nnox=2             !< number of NOx components: NO and NO2
+       INTEGER(iwp)                                 :: nsox=2             !< number of SOX components: SO and SO4
+       INTEGER(iwp)                                 :: nhoursyear         !< number of hours of a specific year in the HOURLY mode
+                                                                          !< of the default mode
+       INTEGER(iwp)                                 :: nmonthdayhour      !< number of month days and hours in the MDH mode 
+                                                                          !< of the default mode
+       INTEGER(iwp)                                 :: dt_emission        !< Number of emissions timesteps for one year 
+                                                                          !< in the pre-processed emissions case
        !-- 1d emission input variables
-       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: pm_name                   !< Names of PMs components
-       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: cat_name                  !< Emission categories names
-       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: species_name              !< Names of emission chemical species
-       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: voc_name                  !< Names of VOCs components
-       CHARACTER (LEN=25)                           :: units                     !< Units
-
-       INTEGER(iwp)                                 :: i_hour                    !< indices for assigning the emission values at different timesteps
-       INTEGER(iwp),ALLOCATABLE, DIMENSION(:)       :: cat_index                 !< Index of emission categories
-       INTEGER(iwp),ALLOCATABLE, DIMENSION(:)       :: species_index             !< Index of emission chem species
-
-       REAL(wp),ALLOCATABLE, DIMENSION(:)           :: xm                        !< Molecular masses of emission chem species
+       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: pm_name       !< Names of PM components
+       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: cat_name      !< Emission category names
+       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: species_name  !< Names of emission chemical species
+       CHARACTER (LEN=25),ALLOCATABLE, DIMENSION(:) :: voc_name      !< Names of VOCs components
+       CHARACTER (LEN=25)                           :: units         !< Units
+
+       INTEGER(iwp)                                 :: i_hour         !< indices for assigning emission values at different timesteps
+       INTEGER(iwp),ALLOCATABLE, DIMENSION(:)       :: cat_index      !< Indices for emission categories
+       INTEGER(iwp),ALLOCATABLE, DIMENSION(:)       :: species_index  !< Indices for emission chem species
+
+       REAL(wp),ALLOCATABLE, DIMENSION(:)           :: xm             !< Molecular masses of emission chem species
 
        !-- 2d emission input variables 
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: hourly_emis_time_factor   !< Time factors for HOURLY emissions (DEFAULT mode)
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: mdh_emis_time_factor      !< Time factors for MDH emissions (DEFAULT mode)
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: nox_comp                  !< Composition of NO and NO2 
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: sox_comp                  !< Composition of SO2 and SO4
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: voc_comp                  !< Composition of different VOC components (number not fixed)
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: hourly_emis_time_factor  !< Time factors for HOURLY emissions (DEFAULT mode)
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: mdh_emis_time_factor     !< Time factors for MDH emissions (DEFAULT mode)
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: nox_comp                 !< Composition of NO and NO2 
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: sox_comp                 !< Composition of SO2 and SO4
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: voc_comp                 !< Composition of VOC components (not fixed)
 
        !-- 3d emission input variables
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)       :: pm_comp                   !< Composition of different PMs components (number not fixed) 
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)       :: pm_comp                  !< Composition of PM components (not fixed) 
   
     END TYPE chem_emis_att_type
 
 
-!-- Data type for the values of chemistry emissions ERUSSO
+!-- Data type for the values of chemistry emissions
     TYPE chem_emis_val_type 
 
-       !REAL(wp),ALLOCATABLE, DIMENSION(:,:)         :: stack_height              !< stack height
-
-       !-- 3d emission input variables
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)     :: default_emission_data     !< Input Values emissions DEFAULT mode
-
-       !-- 4d emission input variables 
-       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:,:)   :: preproc_emission_data      !< Input Values emissions PRE-PROCESSED mode
+       !REAL(wp),ALLOCATABLE, DIMENSION(:,:)     :: stack_height           !< stack height (ecc / to be implemented)
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)    :: default_emission_data  !< Emission input values for LOD1 (DEFAULT mode)
+       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:,:)  :: preproc_emission_data  !< Emission input values for LOD2 (PRE-PROCESSED mode)
 
     END TYPE chem_emis_val_type
@@ -890,5 +910,7 @@
        MODULE PROCEDURE get_variable_4d_real
        MODULE PROCEDURE get_variable_5d_to_4d_real
-       MODULE PROCEDURE get_variable_string       
+       MODULE PROCEDURE get_variable_5d_real           ! (ecc) temp subroutine 4 reading 5D NC arrays
+       MODULE PROCEDURE get_variable_5d_real_dynamic   ! 2B removed as z is out of emission_values
+       MODULE PROCEDURE get_variable_string
     END INTERFACE get_variable
 
@@ -1380,10 +1402,11 @@
 ! Description:
 ! ------------
-!> Reads Chemistry NETCDF Input data, such as emission values, emission species, etc. .
-!------------------------------------------------------------------------------!
+!> Reads Chemistry NETCDF Input data, such as emission values, emission species, etc.
+!------------------------------------------------------------------------------!
+
     SUBROUTINE netcdf_data_input_chemistry_data(emt_att,emt)
 
        USE chem_modules,                                       &
-           ONLY:  mode_emis, time_fac_type, surface_csflux_name
+           ONLY:  emiss_lod, time_fac_type, surface_csflux_name
 
        USE control_parameters,                                 &
